#!/usr/bin/env python
# -*- coding: utf8 -*-
"""
CopyLeft ffsdmad 04.2008
mailto: ffsdmad@gmail.com
модуль подключения, выборки, представления результатов от MySQL
для работы использовать уже инициализированный объект:
bd_sql=Base() -> from base import bd_sql
"""
import config
import MySQLdb


class Base:
	"""
	подключение к Mysql Базе, необходим модуль config
	использовать только инициализированный объект:
	from base import bd_sql
	"""
	db=None
	curs=None
	res=0
	history_sql=""
	def __init__(self):
		if self.db==None and self.curs==None:
			self.db=MySQLdb.connect(config.bdhost,config.bduser,config.bdpass,config.bdname)
			# включение CHARSET соединения
			if len(config.bscharset)>0:
			    self.db.query(config.bscharset)
			try:
				if type(config.id_domen)==int:
					self.db.query("set @id_domen='%d';"%config.id_domen)
				elif type(config.domen)==str:
					self.db.query("set @id_domen=(select id from domen  where domen_name='%s');"%config.domen)
				else:
					self.db.query("set @id_domen='0';")
			except:
				self.db.query("set @id_domen='0';")
				# не заполенно поле domen в конфиге
			self.curs=self.db.cursor()
	def execute(self,SQL_TEXT,COMMENT="",hist=1):
		"""
		выполняет SQL запрос, возвращает количество строк, иначе 0
		"""
		#print (SQL_TEXT,COMMENT)
		if hist:
			self.history_sql+="<sql><![CDATA[%s]]><comment>%s</comment></sql>"%(SQL_TEXT,COMMENT)
		try:
			self.res=self.curs.execute(SQL_TEXT)
			return self.res
		except:
			return 0
	
	def get_row(self,n=0):
		"""
		возвращает n`ую строку результата, иначе None
		"""
		if (n>0) and n <= self.res:
			row={}
			for i in range(0,n):
				row = self.curs.fetchone()
			return row
		if n==0:
			return self.curs.fetchall()
		return None
		
	def get_xml(self,root=None,event=None):
		"""
		возвращает XML представление результатов запроса
		требуется передать имя XML дерева ( <%s>...</%s>,root )
		"""
		fields = []
		xml_str_tmpl="<row>"
		# генерация шаблона строки
		for fl in self.curs.description:
			f0=fl[0]
			fields.append(f0)
			xml_str_tmpl+="<"+f0+">%("+f0+")s</"+f0+">"
		xml_str_tmpl+="</row>"
		# перебор строк
		# xml_str="<rows name='%s'>"%root
		xml_str=""
		for i in range(0,self.res):
			row = self.curs.fetchone()
			rt={}
			# генерация XML документа
			for i in range(len(fields)):
				try:
					rt[fields[i]]=event[fields[i]](row[i])
				except:
					rt[fields[i]]=row[i]
			xml_str+=xml_str_tmpl%rt
		if root:
			return "<"+root+">"+xml_str+"</"+root+">"
		return  xml_str

	def history(self):
		"""возвращает историю sql запросов в виде xml"""
		return "<history_sql>%s</history_sql>"%self.history_sql


bd_sql=Base()
"""
bd_sql - рабочий объект
инициализируется при импорте модуля
"""



