CREATE DATABASE `test_mysql` DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci;

CREATE USER 'test_mysql'@'%' IDENTIFIED BY 'test_mysql';

GRANT USAGE ON * . * TO 'test_mysql'@'%' IDENTIFIED BY 'test_mysql' WITH MAX_QUERIES_PER_HOUR 0 MAX_CONNECTIONS_PER_HOUR 0 MAX_UPDATES_PER_HOUR 0 MAX_USER_CONNECTIONS 0 ;

GRANT SELECT , INSERT , UPDATE , DELETE , CREATE , DROP , INDEX , ALTER , CREATE TEMPORARY TABLES , CREATE VIEW , SHOW VIEW , CREATE ROUTINE, ALTER ROUTINE, EXECUTE ON `test\_mysql` . * TO 'test_mysql'@'%';

CREATE TABLE IF NOT EXISTS test_mysql.ext (
  `id` int(4) NOT NULL auto_increment,
  `date` timestamp NOT NULL default '0000-00-00 00:00:00' on update CURRENT_TIMESTAMP,
  `ext` varchar(20) collate utf8_bin NOT NULL,
  `count` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `ext` (`ext`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=0 ;


CREATE TABLE IF NOT EXISTS test_mysql.files (
  `id` int(6) unsigned NOT NULL auto_increment,
  `date` timestamp NOT NULL default '0000-00-00 00:00:00' on update CURRENT_TIMESTAMP,
  `id_path` int(6) unsigned NOT NULL,
  `file` varchar(400) collate utf8_unicode_ci NOT NULL,
  `id_ext` int(4) unsigned NOT NULL,
  `size` int(6) unsigned NOT NULL,
  `md5` varchar(40) character set utf8 collate utf8_unicode_ci NOT NULL,
  `atime` datetime NOT NULL,
  `ctime` datetime NOT NULL,
  `mtime` datetime NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `file` (`file`(255))
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=0 ;

CREATE TABLE IF NOT EXISTS test_mysql.path (
  `id` int(6) NOT NULL auto_increment,
  `date` timestamp NOT NULL default '0000-00-00 00:00:00' on update CURRENT_TIMESTAMP,
  `path` varchar(400) collate utf8_bin NOT NULL,
  `md5` varchar(40) collate utf8_bin NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `md5` (`md5`),
  KEY `path` (`path`(333))
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=0;

